//
//  ProgrammedViewController.swift
//  Jacques
//
//  Created by Ope on 11/11/16.
//  Copyright © 2016 oooseun. All rights reserved.
//
import UIKit
import CoreBluetooth


class ProgrammedViewController: UIViewController {
    
    weak var countDownTimer  =   Timer()
    var angle:Int = -1 //for rotator
    var speed:Int=0 //for rotator
    var time:Int=0 //for line
    var speedLine:Int=0 //line.
    var rotateVal:Int = 0
    var direction:String = ""
    
    @IBAction func rotateButton(_ sender: Any) {
        
        let alert = UIAlertController(title: "Enter Angle & Speed", message: "", preferredStyle: .alert)
        alert.addTextField { (textField) in
            textField.keyboardType = .numberPad
            textField.placeholder = "Angle in degrees"
        }
        alert.addTextField { (textField) in
            textField.keyboardType = UIKeyboardType.numberPad
            textField.placeholder = "Speed in seconds"
        }
        
        alert.addAction(UIAlertAction(title: "OK", style: .default, handler: { [weak alert] (_) in
            
            if let f1 = alert?.textFields![0].text, let f2 = alert?.textFields![1].text {
                if f2 != "" && f1 != "" {
                    self.angle = Int((f1))!
                    self.speed = Int((f2))! * 1000
                    print("Text field f1: \(self.angle))  && Text field f2: \(self.speed))")
                }
                else
                {print("Text fields empty")}
            }
            if self.angle != -1 && self.speed != 0 {
                
                serial.sendMessageToDevice("ASPD \(self.speed)")
                serial.sendMessageToDevice("ANG \(self.angle)")
                
            }
            
            
            
        }))
        self.present(alert, animated: true, completion: { () ->Void in
        })
        self.speed=0
        self.angle = -1
    }
    @IBAction func lineButton(_ sender: Any) {
        let alert = UIAlertController(title: "Enter Time & Speed", message: "", preferredStyle: .alert)
        alert.addTextField { (textField) in
            textField.keyboardType = .numberPad
            textField.placeholder = "Time in secs"
        }
        alert.addTextField { (textField) in
            textField.keyboardType = .numberPad
            textField.placeholder = "Speed Levels from 0 - 100"
        }
        alert.addTextField { (textField) in
            textField.keyboardType = UIKeyboardType.default
            textField.placeholder = "Enter a direction; UP, DOWN,LEFT,RIGHT"
        }
        
        
        alert.addAction(UIAlertAction(title: "OK", style: .default, handler: { [weak alert] (_) in
            
            if let f1 = alert?.textFields![0].text, let f2 = alert?.textFields![1].text, let f3 = alert?.textFields![2].text {
                if f2 != "" && f1 != "" {
                    self.time = Int((f1))!
                    self.speedLine = Int((f2))!
                    print("Text field f1: \(self.time))  && Text field f2: \(self.speedLine))")
                    if f3 == ""{
                        self.direction = "UP"
                    } else {
                        let f3Uppercased = f3.uppercased()
                        self.direction = f3Uppercased
                    }
                }
                else
                {print("Text fields empty")}
            }
            
            
            if self.speedLine != 0 && self.time != 0 {
                serial.sendMessageToDevice("SPD \(self.speedLine)")
                serial.sendMessageToDevice(self.direction)
                
                
                if self.countDownTimer == nil {
                    self.countDownTimer = Timer.scheduledTimer(timeInterval: TimeInterval(self.time), target: self, selector: #selector(ProgrammedViewController.stop), userInfo: nil, repeats: false)
                    
                }            }
        }))
        self.present(alert, animated: true, completion: { () ->Void in
        })
        
        self.speedLine=0
        self.time=0
        self.direction=""
    }
    @IBAction func stopButton(_ sender: Any) {
        serial.sendMessageToDevice("RST")
        self.angle=0
        self.speed = 0
        countDownTimer?.invalidate()
    }
    func stop(){
        serial.sendMessageToDevice("STP")
    }
    func rotate(){
        if rotateVal < angle {
            rotateVal += 1
            serial.sendMessageToDevice("ANG \(rotateVal)")
        }
    }
    func exitTimerfunc(){
        self.countDownTimer?.invalidate()
        //rotateVal = 0
        countDownTimer = Timer()
    }
    
    override  func viewDidLoad() {
        super.viewDidLoad()
        
    }
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
}
